#parse Canon lenses datafile, written by SaveLensToFile (LENS00.bin)
#see http://cpn.canon-europe.com/content/education/masterclass/peripheral_illumination_correction.do
#see http://www.sno.phy.queensu.ca/~phil/exiftool/TagNames/Canon.html#LensType 
#call sub_ff019f70 in 550d 109

import sys
from struct import unpack

def getLongLE(d, a):
   return unpack('<L',(d)[a:a+4])[0]

def getShortLE(d, a):
   return unpack('<H',(d)[a:a+2])[0]

f = open(sys.argv[1], 'rb')
m = f.read()
f.close()

#directory at 0x50
n = 0
for i in range(40):
  lens_id = getShortLE(m, 0x50+i*8)
  if lens_id==0:
    break
  n = n + 1
  offset = getLongLE(m,0x50+i*8+4)
  print '%04x: %4d, 0x%x' % (0x50+i*8, lens_id, offset)

#lens data start at 0x450 (to be verified), each record is 0x370 bytes long
for i in range(n):
  focal1 = getShortLE(m, 0x450+i*0x370+4) 
  focal2 = getShortLE(m, 0x450+i*0x370+6)
  print '%04x: %dmm-%dmm' % (0x450+i*0x370, focal1, focal2)   